summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorJérémy Zurcher <jeremy@asynk.ch>2011-06-14 09:11:16 +0200
committerJérémy Zurcher <jeremy@asynk.ch>2011-06-14 09:11:16 +0200
commitc4810170979d2d2fb9cf1100c6345556c5ac01a8 (patch)
treeae3bddde2c470acffa19da34d23a32b9cb50fc4c
parenta6741366902aff22e5b7b94fff543bdc82b74ef8 (diff)
downloadbin-c4810170979d2d2fb9cf1100c6345556c5ac01a8.zip
bin-c4810170979d2d2fb9cf1100c6345556c5ac01a8.tar.gz
add xx2yy
-rwxr-xr-xpdf2txt15
-rwxr-xr-xrdoc2html3
-rwxr-xr-xsh2html415
-rwxr-xr-xxlsx2csv1187
4 files changed, 1620 insertions, 0 deletions
diff --git a/pdf2txt b/pdf2txt
new file mode 100755
index 0000000..e8632be
--- /dev/null
+++ b/pdf2txt
@@ -0,0 +1,15 @@
+#! /bin/sh
+
+if [ $# -eq 0 ]; then
+ echo "usage $0 : pdffile"
+fi
+
+TIFF=$(basename $1 .pdf).tif
+OUTF=$(basename $1 .pdf)
+
+FMT=${TIFF_FMT:-"tiffgray"} #tiff24nc
+
+gs -r300x300 -sDEVICE=${FMT} -sOutputFile=$TIFF -dBATCH -dNOPAUSE $1
+tesseract $TIFF $OUTF
+rm $TIFF
+echo "output : ${OUTF}"
diff --git a/rdoc2html b/rdoc2html
new file mode 100755
index 0000000..b0968ca
--- /dev/null
+++ b/rdoc2html
@@ -0,0 +1,3 @@
+#! /usr/bin/env ruby
+require 'rdoc/markup/to_html'
+puts RDoc::Markup::ToHtml.new.convert(ARGF.read)
diff --git a/sh2html b/sh2html
new file mode 100755
index 0000000..3707e25
--- /dev/null
+++ b/sh2html
@@ -0,0 +1,415 @@
+#!/bin/sh
+#< Convert a shell script into HTML, with syntax highlighting
+#
+# (C) 2004 Kevin Waldron
+# Released under the terms of the GNU General Public Licence
+#
+# Most modern Bourne Shell features are implemented here. Other
+# common external commands are also implemented. We can't implement
+# everything that may exist in everyones PATH's however!!
+
+if [ "$#" -ne "2" ]; then
+ echo "Usage: $(basename $0) filename outputfile" && exit 1
+fi
+
+O_FILE=$2
+
+if [ -e "${O_FILE}" ]; then
+ echo "$(basename $0): Error: ${O_FILE} already exists" && exit 1
+fi
+
+I_FILE=$1
+
+if [ ! -e "${I_FILE}" ]; then
+ echo "$(basename $0): Error: ${I_FILE} does not exist" && exit 1
+fi
+
+# Print standard header stuff to file
+
+#echo "<html>" >> ${O_FILE}
+#echo "<head>" >> ${O_FILE}
+#echo "<!-- Generated with sh2html - http://www.zazzybob.com -->" >> ${O_FILE}
+#echo "<title>$(basename ${I_FILE})</title>" >> ${O_FILE}
+#echo "</head>" >> ${O_FILE}
+#echo "<body>" >> ${O_FILE}
+echo "<pre>" >> ${O_FILE}
+
+# main awk routine - syntax highlighting done here!
+awk '{
+ # these gsubs globally replace special chars
+ gsub( "&", "\\&amp;", $0 );
+ gsub( "<", "\\&lt;", $0 );
+ gsub( ">", "\\&gt;", $0 );
+
+
+ commandArray[0] = "awk";
+ commandArray[1] = "read";
+ commandArray[2] = "exit";
+ commandArray[3] = "ls";
+ commandArray[4] = "rm";
+ commandArray[5] = "sort";
+ commandArray[6] = "uniq";
+ commandArray[7] = "sed";
+ commandArray[8] = "mv";
+ commandArray[9] = "cp";
+ commandArray[10] = "join";
+ commandArray[11] = "grep";
+ commandArray[12] = "cat";
+ commandArray[13] = "df";
+ commandArray[14] = "cd";
+ commandArray[15] = "basename";
+ commandArray[16] = "id";
+ commandArray[17] = "tr";
+ commandArray[18] = "ls";
+ commandArray[19] = "true";
+ commandArray[20] = "false";
+ commandArray[21] = "seq";
+ commandArray[22] = "cut";
+ commandArray[23] = "getopt";
+ commandArray[24] = "getopts";
+ commandArray[25] = "gunzip";
+ commandArray[26] = "gzip";
+ commandArray[27] = "tar";
+ commandArray[28] = "date";
+ commandArray[29] = "clear";
+ commandArray[30] = "ps";
+ commandArray[31] = "ifconfig";
+ commandArray[32] = "ping";
+ commandArray[33] = "tput";
+ commandArray[34] = "useradd";
+ commandArray[35] = "passwd";
+ commandArray[36] = "stty";
+ commandArray[37] = "chown";
+ commandArray[38] = "chmod";
+ commandArray[39] = "trap";
+ commandArray[40] = "sleep";
+ commandArray[41] = "wait";
+ commandArray[42] = "last";
+ commandArray[43] = "head";
+ commandArray[44] = "let";
+ commandArray[45] = "shift";
+ commandArray[46] = "unalias";
+ commandArray[47] = "read";
+ commandArray[48] = "unset";
+ commandArray[49] = "alias";
+ commandArray[50] = "expr";
+ commandArray[51] = "printf";
+ commandArray[52] = "mkdir";
+ commandArray[53] = "declare";
+ commandArray[54] = "local";
+ commandArray[55] = "tail";
+ commandArray[56] = "hostname";
+ commandArray[57] = "xterm";
+ commandArray[58] = "bc";
+ commandArray[59] = "wc";
+ commandArray[60] = "more";
+ commandArray[61] = "find";
+ commandArray[62] = "mount";
+ commandArray[63] = "who";
+ commandArray[64] = "suspend";
+ commandArray[65] = "ulimit";
+ commandArray[66] = "umask";
+ commandArray[67] = "source";
+ commandArray[68] = "bind";
+ commandArray[69] = "builtin";
+ commandArray[70] = "typeset";
+ commandArray[71] = "export";
+ commandArray[72] = "fc";
+ commandArray[73] = "history";
+ commandArray[74] = "hash";
+ commandArray[75] = "jobs";
+ commandArray[76] = "kill";
+ commandArray[77] = "fg";
+ commandArray[78] = "bg";
+ commandArray[79] = "logout";
+ commandArray[80] = "popd";
+ commandArray[81] = "pushd";
+ commandArray[82] = "pwd";
+ commandArray[83] = "shopt";
+ commandArray[84] = "test";
+ commandArray[85] = "touch";
+
+ # update array_length manually below!
+ array_length = 85;
+
+ # deal with comments first - ignore entire line if one is found
+ if ( $0 ~ /^[ ]*#/ ) {
+ print "<font color=\"green\"><i>"$0"</i></font>";
+ }
+ else {
+ # syntax highlight on a line-by-line, element-by-element basis
+ # dealing with echo firstly, so we can say echo "echo if else"
+ # and only have the "echo" highlighted
+ if ( $0 ~ /^[ ]*echo/ ) {
+ gsub( /^[ ]*echo/, "<b>&</b>", $0 );
+ gsub( /;[ ]*echo/, "; <b>echo</b>", $0 );
+
+ # check for commands within ` and ( in echo
+ for ( i = 0; i <= array_length; i++ ) {
+ x=commandArray[i];
+
+ if ( $0 ~ x ) {
+ reg = "[(]"x"[ ]*";
+ gsub( reg, "(<b>"x"</b> ", $0 );
+ reg = "[(][ ]+"x"[ ]+";
+ gsub( reg, "( <b>"x"</b> ", $0 );
+ reg = "[`]"x"[ ]*";
+ gsub( reg, "`<b>"x"</b> ", $0 );
+ reg = "[`][ ]+"x"[ ]+";
+ gsub( reg, "` <b>"x"</b> ", $0 );
+ reg = "^[ ]*"x"[ ]*$";
+ gsub( reg, "<b>&</b>", $0 );
+ reg = "[ ]+"x"[ ]+";
+ gsub( reg, "<b>&</b>", $0 );
+ }
+ }
+ }
+ else {
+ # catch other echos - i.e. with case
+ gsub( /[ ]*echo[ ]+/, "<b>&</b>", $0 );
+
+ # if - will be at start of line (usually)
+ gsub( /if test/,
+ "<font color=\"blue\"><b>if</b></font> <b>test</b>", $0 );
+ gsub( /^[ ]*if[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /^[ ]*if[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # else - will be at start of line (usually)
+ gsub( /^[ ]*else[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # elif - will be at start of line (usually)
+ gsub( /^[ ]*elif[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # fi - will also usually be at the start of a line
+ gsub( /^[ ]*fi[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # for - will be at start of line (usually)
+ gsub( /^[ ]*for[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # select - will be at start of line (usually)
+ gsub( /^[ ]*select[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # while - will be at start of line (usually)
+ gsub( /while read/,
+ "<font color=\"blue\"><b>while</b></font> <b>read</b>", $0 );
+ gsub( /^[ ]*while[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # until - will be at start of line (usually)
+ gsub( /^[ ]*until[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # case - will be at start of line (usually)
+ gsub( /^[ ]*case[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # esac - will be at start of line (usually)
+ gsub( /^[ ]*esac[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # function - will be at start of line (usually)
+ gsub( /^[ ]*function[ ]+/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # done - will be at start of line (usually)
+ gsub( /^[ ]*done[ ]*/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+
+ # then - can be at start of line, or after a ;
+ gsub( /^[ ]*then[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /;[ ]*then[ ]*$/,
+ "; <font color=\"blue\"><b>then</b></font>", $0 );
+
+ # special case - then followed by comment
+ if ( /[ ]*then[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /then/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - do followed by comment
+ if ( /[ ]*do[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /do/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - else followed by comment
+ if ( /[ ]*else[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /else/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - break followed by comment
+ if ( /[ ]*break[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /break/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - continue followed by comment
+ if ( /[ ]*continue[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /continue/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - done followed by comment
+ if ( /[ ]*done[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /done/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - fi followed by comment
+ if ( /[ ]*fi[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /fi/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # special case - esac followed by comment
+ if ( /[ ]*esac[ ]*#/ ) {
+ gsub( /[^$]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ gsub( /esac/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ }
+
+ # do - can be at start of line, or after a ;
+ gsub( /^[ ]*do[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /;[ ]*do[ ]*$/,
+ "; <font color=\"blue\"><b>do</b></font>", $0 );
+
+ # continue - can be at start of line, or after a ;
+ gsub( /^[ ]*continue[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /;[ ]*continue[ ]*$/,
+ "; <font color=\"blue\"><b>continue</b></font>", $0 );
+ gsub( /continue;/,
+ "<font color=\"blue\"><b>continue</b></font>;", $0 );
+
+ # break - can be at start of line, or after a ; or ending in ;
+ gsub( /^[ ]*break[ ]*$/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /;[ ]*break[ ]*$/,
+ "; <font color=\"blue\"><b>break</b></font>", $0 );
+ gsub( /break[ ]*;/,
+ "<font color=\"blue\"><b>break</b></font> ;", $0 );
+
+ # return - can be at start of line, or after a ;
+ gsub( /^[ ]*return[ ]*/,
+ "<font color=\"blue\"><b>&</b></font>", $0 );
+ gsub( /;[ ]*return[ ]*/,
+ "; <font color=\"blue\"><b>return</b></font>", $0 );
+
+ # scan for more comments - probably makes some of the code
+ # above redundant! A bit of a "catch all" for comments that
+ # slip through the net.
+ if ( /[^${#]#[^#]/ ) {
+ gsub( /[^$^]#.*$/,
+ "<font color=\"green\"><i>&</i></font>", $0 );
+ }
+
+ # exec - special case as more commands may follow it
+ if ( /[^#][ ]*exec[ ]*/ ) {
+ gsub( /exec/, "<b>&</b>", $0 );
+ }
+ if ( /^exec/ ) { gsub ( /exec/, "<b>exec</b>", $0 ); }
+
+
+ # eval - special case as more commands may follow it
+ if ( /[^#][ ]*eval[ ]*/ ) {
+ gsub( /eval/, "<b>&</b>", $0 );
+ }
+
+ # set - to allow tput reset
+ if ( /set/ ) {
+ gsub( /^[ ]*set/, "<b>&</b>", $0 );
+ }
+
+ for ( i = 0; i <= array_length; i++ ) {
+ x=commandArray[i];
+
+ if ( $0 ~ x ) {
+ reg = "[(]"x"[ ]*";
+ gsub( reg, "(<b>"x"</b> ", $0 );
+ reg = "[(][ ]+"x"[ ]+";
+ gsub( reg, "( <b>"x"</b> ", $0 );
+ reg = "[`]"x"[ ]*";
+ gsub( reg, "`<b>"x"</b> ", $0 );
+ reg = "[\047]"x"[ ]*";
+ gsub( reg, "\047<b>"x"</b> ", $0 );
+ reg = "[\042]"x"[ ]*";
+ gsub( reg, "\042<b>"x"</b> ", $0 );
+ reg = "[`][ ]+"x"[ ]+";
+ gsub( reg, "` <b>"x"</b> ", $0 );
+ reg = "[ ]+"x"[ ]+";
+ gsub( reg, "<b>&</b>", $0 );
+ reg = x";";
+ gsub( reg, "<b>"x"</b>;", $0 );
+ reg = "^[ ]*"x"[ ]+";
+ gsub( reg, "<b>&</b>", $0 );
+ reg = "[ ]*"x"[`]";
+ gsub( reg, " <b>"x"</b>`", $0 );
+ reg = "[ ]*"x"[)]";
+ gsub( reg, " <b>"x"</b>)", $0 );
+ reg = "[ ]*"x"[ ]+[`]";
+ gsub( reg, " <b>"x"</b> `", $0 );
+ reg = "[ ]*"x"[ ]+[)]";
+ gsub( reg, " <b>"x"</b> )", $0 );
+ reg = "^[ ]*"x"[ ]*$";
+ gsub( reg, "<b>&</b>", $0 );
+ reg = "[|][ ]+"x;
+ gsub( reg, "| <b>"x"</b>", $0 );
+ }
+ }
+
+ # some comparison ops
+ gsub( /[ ]+\-gt[ ]+/, " <b>-gt</b> ", $0 );
+ gsub( /[ ]+\-lt[ ]+/, " <b>-lt</b> ", $0 );
+ gsub( /[ ]+\-eq[ ]+/, " <b>-eq</b> ", $0 );
+ gsub( /[ ]+\-ne[ ]+/, " <b>-ne</b> ", $0 );
+ gsub( /[ ]+\-ge[ ]+/, " <b>-ge</b> ", $0 );
+ gsub( /[ ]+\-le[ ]+/, " <b>-le</b> ", $0 );
+ gsub( /[ ]+\-a[ ]+/, " <b>-a</b> ", $0 );
+ gsub( /[ ]+\-o[ ]+/, " <b>-o</b> ", $0 );
+ gsub( /[ ]+\-n[ ]+/, " <b>-n</b> ", $0 );
+ gsub( /[ ]+\![ ]+/, "<b> !</b> ", $0 );
+ gsub( /[ ]+\-e[ ]+/, " <b>-e</b> ", $0 );
+ gsub( /[ ]+\-z[ ]+/, " <b>-z</b> ", $0 );
+ gsub( /[ ]+\-f[ ]+/, " <b>-f</b> ", $0 );
+ }
+ # print out the line now we are all gsubbed
+ print $0
+ }
+}' ${I_FILE} >> ${O_FILE}
+
+# print website plug - please leave in to "spread the word"
+echo "<br><br>" >> ${O_FILE}
+echo "<font color=\"green\"><i># Generated with sh2html - freely available from http://www.zazzybob.com/sh2html.html</i></font>" >> ${O_FILE}
+
+# print standard footer stuff to file
+
+echo "</pre>" >> ${O_FILE}
+#echo "</body>" >> ${O_FILE}
+#echo "</html>" >> ${O_FILE}
+
+exit 0
diff --git a/xlsx2csv b/xlsx2csv
new file mode 100755
index 0000000..c731615
--- /dev/null
+++ b/xlsx2csv
@@ -0,0 +1,1187 @@
+#!/bin/bash
+#===============================================================================
+#
+# FILE: xlsx2csv.sh
+#
+# USAGE: ./xlsx2csv.sh [-c|--copyleft] [-d|--debug] [-v|--version] -x[|--xlsx] filename
+#
+# DESCRIPTION: Read an MS excel SpreadsheetML document
+# extract the data to csv
+#
+# REQUIREMENTS: unzip | xsltproc | libxml | sqlite3 | gnu sed
+# BUGS: doesn't read formatting, macros
+# NOTES: does translate dates correctly! also handles null data
+# quotes and commas delimited, embedded quotes are doubled
+# AUTHOR: Kirk Roybal (DBA)
+# http://kirk.webfinish.com
+# CREATED: 12/02/2009 10:06:45 CST
+# REVISION: ---
+# CREDITS:
+# openxmldeveloper.org for describing the format of excel date serial
+# http://openxmldeveloper.org/articles/using_Spreadsheet_ML_document__as_datasource_for_heterogenous_applicationss.aspx
+# http://www.ccechile.org/eventos/2007/docs/document/Response-various_Dates.pdf
+# http://www.codeproject.com/KB/XML/ooxml_is_defective.aspx
+# http://openxmldeveloper.org/forums/thread/597.aspx
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+# Release notes:
+# 1.0 (2009/12/18) -- First release available to the public
+# 1.1 (2010/01/12) -- Improved date handling routine to look for all common date formats in Excel.
+#===============================================================================
+version="1.1"
+
+function usage () {
+ cat <<EOS
+ Usage: $(basename $0) [-c|--copyleft] [-d|--debug] [-v|--version] -x[|--xlsx] filename
+EOS
+}
+
+[[ $# -gt 0 ]] || {
+ usage
+ exit 1
+}
+
+for arg
+do
+ delim=""
+ case "$arg" in
+ #translate --gnu-long-options to -g (short options)
+ --copyleft) args="${args}-c ";;
+ --xlsx) args="${args}-x ";;
+ --debug) args="${args}-d ";;
+ --version) args="${args}-v ";;
+ #pass through anything else
+ *) leftchar=$(printf %1.1s "$arg")
+ [[ ! "$leftchar" == "-" ]] && delim="\""
+ args="${args}${delim}${arg}${delim} "
+ ;;
+ esac
+done
+
+
+#Reset the positional parameters to the short options
+eval set -- $args
+
+while getopts ":cdvx:" option 2>/dev/null
+do
+ case $option in
+ c) tail -n 650 "$0" | head -n 621 | sed 's/^# //' #copyleft
+ exit ;;
+ d) set -x #debug
+ debug=true;;
+ v) echo $(basename "$0") $version; exit;; #version
+ x) filename=${OPTARG};; #xlsx
+ *) echo $OPTARG is an unrecognized option;;
+ esac
+done
+
+[[ -z "$filename" ]] && {
+ usage
+ cat <<EOS
+ Filename is required.
+EOS
+ exit 2
+}
+
+[[ -f "$filename" ]] || {
+ cat <<EOS
+ File not found.
+EOS
+ exit 2
+
+}
+
+#find out what inode we're in
+appdir=$(dirname $0)
+[[ "$appdir" == "." ]] && appdir=$(pwd)
+curdir=$(pwd)
+appname=$(basename $0)
+
+#set up some platform specific utilities
+gnused=sed
+platform=$(uname -s)
+[[ "${platform}" == "Darwin" ]] && gnused=gsed
+
+#Make a working directory based on the filename
+dirname=$(echo "$filename" | sed -e 's/\.xlsx$//g' -e 's/[[:space:]]/_/g')
+[[ -d "$dirname" ]] || mkdir "$dirname"
+#copy the source file into it
+cp "$filename" "$dirname"
+#get in there and push
+pushd "$dirname" > /dev/null
+
+workfilename="$(basename "$filename")"
+# Unpack the xlsx file
+unzip -q "$workfilename"
+#Did we get the expected structure?
+[[ ! -d "xl" ]] && {
+ echo $filename is not an xlsx format file
+ popd
+ rm -rf "$dirname"
+ exit 1
+}
+
+#Make a sqlite3 database to do some relational work
+sdbname="$(pwd)/${dirname}.sdb"
+[[ $(hostname) == "wsmkroybal.javelin.pvt" ]] && {
+ sdbname="/Users/kroybal/sdb/${dirname}.sdb"
+ [[ -f "$sdbname" ]] && rm "$sdbname"
+}
+
+#Create an SQL based string table
+sql="CREATE TABLE shared_strings (
+ id INTEGER PRIMARY KEY AUTOINCREMENT,
+ value string);"
+sqlite3 "$sdbname" "$sql" #The first access of the db will create the file
+
+#turn the starting tags directly into newline
+newline=$(echo -e '\n\r')
+
+#turn the xml for shared strings into sqlite sql
+cat "xl/sharedStrings.xml" |
+ sed -e "s/<rPr>.*<\/rPr>//g" > "xl/sharedStrings.sed"
+#blow away embedded garbage
+$gnused -i -e "s/<r><t>.<\/t><\/r>//g" -e "s/<si>/\\$newline/g" "xl/sharedStrings.sed"
+$gnused -i -e "s/<\/t>.$//g" -e "s/<t>//g" -e "/^[:space:]]*$/d" "xl/sharedStrings.sed"
+$gnused -i -e "s/<t xml:space=\"preserve\">//g" -e 's/<r>//g' "xl/sharedStrings.sed"
+#remove any non-printable characters, the xml tag line, and the DTD
+$gnused -i -e "s/[^[:graph:] ]*//g" -e "1,2d" -e "s/'/''/g" -e 's/amp;//g' "xl/sharedStrings.sed"
+#blow off any formatting junk after the closing tag
+$gnused -i -e "s/<\/t>.*$//" -e "/^$/d" "xl/sharedStrings.sed"
+#trim the result
+#sed -i '' -e 's/^[[:space:]]*//g' -e 's/[[:space:]]*$//g' "xl/sharedStrings.sed"
+#make a sql statement out of the result
+$gnused -i -e "s/^/INSERT INTO shared_strings (value) VALUES ('/" -e "s/$/');/" "xl/sharedStrings.sed"
+#load the stringtable
+sqlite3 "$sdbname" < "xl/sharedStrings.sed"
+
+sql="CREATE INDEX idx_ss ON shared_strings(id,value);"
+sqlite3 "$sdbname" "$sql"
+
+sql="CREATE TABLE sheets (
+id INTEGER PRIMARY KEY,
+name varchar(200),
+ordinal integer,
+rid integer);"
+sqlite3 "$sdbname" "$sql"
+
+#make an xslt file to import the sheet names
+xsl="<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">
+<xsl:output method=\"text\"/>
+<xsl:template match=\"sheets\">
+ <xsl:apply-templates select=\"sheet\"/>
+</xsl:template>
+<xsl:template match=\"sheet\">
+ INSERT INTO sheets(name,ordinal,rid) VALUES ('<xsl:value-of select=\"translate(@name,&quot;'&quot;,&quot;&quot;)\"/>',<xsl:value-of select=\"@sheetId\"/>,<xsl:value-of select=\"@rid\"/>);
+</xsl:template>
+</xsl:stylesheet>"
+echo -e "$xsl" > "xl/sheets.xsl"
+
+#make a simpler xml file to parse
+cat "xl/workbook.xml" |
+ sed -e 's/.*<sheets/<sheets/' -e 's/r:id/rid/g' |
+ sed -e 's/<\/sheets>.*/<\/sheets>/' -e 's/"rId/"/g' > "xl/sheets.xml"
+#import the sheet names
+xsltproc "xl/sheets.xsl" "xl/sheets.xml" | sqlite3 "$sdbname"
+
+#import the format styles
+sql="CREATE TABLE fmt_data (
+id INTEGER PRIMARY KEY,
+numfmtid integer,
+formatcode varchar(200));"
+sqlite3 "$sdbname" "$sql"
+
+#import the format data
+fmtxsl="<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">
+<xsl:output method=\"text\"/>
+<xsl:template match=\"numFmts\">
+ <xsl:apply-templates select=\"numFmt\"/>
+</xsl:template>
+<xsl:template match=\"numFmt\">
+ INSERT INTO fmt_data(numfmtid,formatcode) VALUES ('<xsl:value-of select=\"@numFmtId\"/>','<xsl:value-of select=\"@formatCode\"/>');
+</xsl:template>
+</xsl:stylesheet>"
+
+#create an xsl stylesheet for formats
+echo -e "$fmtxsl" > 'xl/fmt.xsl'
+
+#simplify the input file
+cat "xl/styles.xml" | sed -e 's/^.*<numFmts/<numFmts/' -e 's/<\/numFmts>.*/<\/numFmts>/' > "xl/fmts.xml"
+#import the formats
+xsltproc "xl/fmt.xsl" "xl/fmts.xml" | sqlite3 "$sdbname"
+
+#associate the formats to cells
+sql="CREATE TABLE fmt2cell_data (
+id INTEGER PRIMARY KEY,
+numfmtid integer);"
+sqlite3 "$sdbname" "$sql"
+
+#now import the format 2 field mapping table
+fmtxsl="<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">
+<xsl:output method=\"text\"/>
+<xsl:template match=\"cellXfs\">
+ <xsl:apply-templates select=\"xf\"/>
+</xsl:template>
+<xsl:template match=\"xf\">
+ INSERT INTO fmt2cell_data(numfmtid) VALUES ('<xsl:value-of select=\"@numFmtId\"/>');
+</xsl:template>
+</xsl:stylesheet>"
+
+#create an xsl stylesheet for formats
+echo -e "$fmtxsl" > 'xl/fmt2cell.xsl'
+
+#simplify the input file
+cat "xl/styles.xml" | sed -e 's/^.*<cellXfs/<cellXfs/' |
+ sed -e 's/<\/cellXfs>.*/<\/cellXfs>/' > "xl/fmt2cell.xml"
+#import the mapping
+xsltproc "xl/fmt2cell.xsl" "xl/fmt2cell.xml" | sqlite3 "$sdbname"
+
+#delete the formats that obviously have nothing to do with dates.
+sql="DELETE FROM fmt2cell_data WHERE numfmtid=0;"
+sqlite3 "$sdbname" "$sql"
+
+#create a table of known date formats
+sql="CREATE TABLE date_formats (
+id INTEGER PRIMARY KEY,
+format varchar(500));"
+sqlite3 "$sdbname" "$sql"
+
+#Insert all the date formats we know about
+insert="INSERT INTO \"date_formats\" (format) VALUES"
+sql="
+$insert ('[\$-F800]dddd\,\ mmmm\ dd\,\ yyyy');
+$insert ('m/d;@');
+$insert ('mmm\ d');
+$insert ('m/d/yy;@');
+$insert ('mm/dd/yy;@');
+$insert ('m/d/yyyy;@');
+$insert ('m/d/yy\ h:mm;@');
+$insert ('[\$-409]mmmmm;@');
+$insert ('[\$-409]d\-mmm;@');
+$insert ('[\$-409]mmm\-yy;@');
+$insert ('[\$-409]mmmm\-yy;@');
+$insert ('[\$-409]mmmmm\-yy;@');
+$insert ('[\$-409]d\-mmm\-yy;@');
+$insert ('[\$-409]d\-mmm\-yyyy;@');
+$insert ('[\$-409]mmmm\ d\,\ yyyy;@');
+$insert ('[\$-409]m/d/yy\ h:mm\ AM/PM;@');
+--$insert ('_(* #,##0_);_(* \(#,##0\);_(* \"-\"_);_(@_)');
+--$insert ('_(* #,##0_);_(* \(#,##0\);_(* \"-\"??_);_(@_)');
+--$insert ('_(* #,##0.0_);_(* \(#,##0.0\);_(* \"-\"?_);_(@_)');
+--$insert ('_(* #,##0.0_);_(* \(#,##0.0\);_(* \"-\"??_);_(@_)');
+--$insert ('_(* #,##0.00_);_(* \(#,##0.00\);_(* \"-\"??_);_(@_)');
+--$insert ('_(* #,##0.0000_);_(* \(#,##0.0000\);_(* \"-\"??_);_(@_)');
+--$insert ('_(\"$\"* #,##0.00_);_(\"$\"* \(#,##0.00\);_(\"$\"* \"-\"??_);_(@_)');
+--$insert ('_(\"$\"* #,##0.000_);_(\"$\"* \(#,##0.000\);_(\"$\"* \"-\"??_);_(@_)');
+"
+sqlite3 "$sdbname" "$sql"
+
+#see if anything matches the dates we know about
+sql="UPDATE fmt_data SET formatcode = 'date' where formatcode IN
+ (SELECT format FROM date_formats);"
+sqlite3 "$sdbname" "$sql"
+
+#propagate the formats from the fmt_data table
+# to the fmt2cell_data table
+sql="REPLACE INTO fmt2cell_data (id,numfmtid)
+ select fc.id, fd.formatcode
+ FROM fmt2cell_data fc INNER JOIN fmt_data fd
+ ON fc.numfmtid = fd.numfmtid
+ WHERE fd.formatcode='date';"
+sqlite3 "$sdbname" "$sql"
+
+sql="CREATE TABLE cell_data (
+ id INTEGER PRIMARY KEY AUTOINCREMENT,
+ sheet varchar(255),
+ cell varchar(200),
+ style integer,
+ type varchar(3),
+ value varchar(200),
+ row integer,
+ col varchar(20)
+);"
+# Leftovers from date calculation improvements
+# a integer,
+# b integer,
+# c integer,
+# d integer,
+# e integer,
+# f integer,
+# g integer,
+# y integer,
+# m integer,
+# day integer
+sqlite3 "$sdbname" "$sql"
+
+#extract the data for each sheet to sqlite
+cd xl/worksheets/
+
+#xsltproc requires the style sheet as a file
+tail -n 27 "$appdir/$appname" > data.xsl
+
+for file in *.xml
+do
+ #Remove the formatting we can't read anyway to make the xslt parser simpler.
+ # remove any trailing lines after the sheetData
+ cat "$file" | sed -e 's/.*<sheetData/<sheetData/' |
+ sed -e 's/<\/sheetData>.*/<\/sheetData>/' -e '3,$d' > "${file}.data"
+
+ #translate the data into sqlite INSERT statements
+ # 3 copies of sed streaming are an intentional speed enhancement.
+ xsltproc data.xsl "${file}.data" |
+ sed -e "s/'/''/g" -e "s/|/'/g" | sed -e 's/&amp;/&/g' |
+ sed -e "/'');[[:space:]]*$/d" | sqlite3 "$sdbname"
+# > "${file}.sql"
+# < "${file}.sql"
+
+ #Add the sheet name to the data we just imported
+ bname=$(basename "$file" .xml | sed -e "s/'//g" -e 's/[[:alpha:]]*//g')
+ sql="UPDATE cell_data SET sheet=(SELECT name FROM sheets WHERE rid = ${bname})
+ WHERE sheet is null;"
+ sqlite3 "$sdbname" "$sql"
+done
+
+#remove any blank cells
+sql="DELETE FROM cell_data WHERE value = '';"
+sqlite3 "$sdbname" "$sql"
+
+#index the type column
+sql="CREATE INDEX idx_cd ON cell_data(type);"
+sqlite3 "$sdbname" "$sql"
+
+#shared string table is zero based in file, 1 based in sdb
+sql="UPDATE cell_data SET value=value+1 WHERE type='s';"
+sqlite3 "$sdbname" "$sql"
+
+#update the cells with the string data
+sql="REPLACE INTO cell_data(id,value,sheet,cell,style,type,row,col)
+ SELECT cd.id, ss.value, cd.sheet, cd.cell, 'str', '', cd.row, cd.col
+ FROM shared_strings ss INNER JOIN cell_data cd ON ss.id = cd.value
+ WHERE cd.type = 's';"
+sqlite3 "$sdbname" "$sql"
+
+#basic data formats with id<=40 that are dates.
+# these are not supplied in the xlsx file
+sql="UPDATE fmt2cell_data SET numfmtid = 'date'
+ WHERE numfmtid IN (14,16);"
+sqlite3 "$sdbname" "$sql"
+
+#Other subformats that are also dates.
+sql="REPLACE INTO cell_data (id,value,sheet,cell,style,type,row,col)
+ SELECT cd.id, cd.value,cd.sheet,cd.cell,'2','d',cd.row,cd.col
+ FROM cell_data cd INNER JOIN fmt2cell_data fc ON cd.style+1=fc.id
+ WHERE fc.numfmtid = 'date' and cd.style <> '2'
+ AND cd.type='' AND cd.value<>'';";
+sqlite3 "$sdbname" "$sql"
+
+#Fix the Y1900 leap year bug
+sql="UPDATE cell_data SET value='1900-02-29 00:00:00',style='s'
+ WHERE value=60 AND style='2';"
+sqlite3 "$sdbname" "$sql"
+
+#Other dates less than 60 are off by 1
+sql="UPDATE cell_data SET value=value+1 WHERE value < 60 AND style='2';"
+sqlite3 "$sdbname" "$sql"
+
+#convert the Julian serial to date
+# add days to convert to unix epoch
+# convert epoch to ISO date as text
+# end up with YYYY-MM-DD
+#Much easier and more reliable
+sql="UPDATE cell_data SET value=datetime(value+2415017.5)
+ WHERE style='2' and value <> '';"
+sqlite3 "$sdbname" "$sql"
+
+[[ -z "A" ]] && {
+#old school date calculation
+# this code is a non-buggy implementation of the
+# buggy code found at
+# http://www.codeproject.com/KB/datetime/exceldmy.aspx?print=true
+# The basic idea here is to convert the date to a unix epoch
+# add some days to make sure that 1970-01-01 < date < 2038-01-01
+# because MS date functions only work properly within that range
+# then re-implement MS date math logic to find the date
+# then subtract the bias in years from the date.
+# We don't do things like that in Linux land.
+sql="UPDATE cell_data SET a=value+68569+2415019 WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET b=cast((4*a)/146097.0 as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET c=a-((146097*b+3)/4) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET d=cast((4000*(c+1))/1461001.0 as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET e=(c-cast(1461.0*d/4 as integer)+31 WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET f=cast((80*e)/2447 as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET g=cast(f/11 as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET day=e-cast((2447.0*f)/80 as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET m=cast(f+2.0-(12.0*g) as integer) WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+sql="UPDATE cell_data SET y=100*(b-49)+d+g WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+
+#Finally! We have a date!
+sql="UPDATE cell_data
+ SET value=y || '-' || m || '-' || day, style='' WHERE style='2';"
+sqlite3 "$sdbname" "$sql"
+}
+
+#don't show nulls as '-' (dash)
+sql="UPDATE cell_data SET value='', style='' WHERE style='3';"
+sqlite3 "$sdbname" "$sql"
+
+#get the row numbers as integers
+#Get the column indices as letters [A-ZZ]
+sql="UPDATE cell_data
+ SET row=CAST(trim(cell,'ABCDEFGHIJKLMNOPQRSTUVWXYZ') as int),
+ col=trim(cell,'0123456789');"
+sqlite3 "$sdbname" "$sql"
+
+#blow away CRLF in the values
+sql="UPDATE cell_data SET value=replace(value,x'0d','');"
+sql="$sql UPDATE cell_data SET value=replace(value,x'0a','');"
+sqlite3 "$sdbname" "$sql"
+
+#set up column list from A-ZZ collated in spreadsheet order
+sql="CREATE TABLE columns ( id integer primary key, title varchar(3));"
+sqlite3 "$sdbname" "$sql"
+#create A-Z
+for ((i=65;i<=90;i++))
+do
+ #convert ascii value to char
+ char=$(printf "\\$(printf "%03o" $i)")
+ #insert into db
+ sql="INSERT INTO columns (title) VALUES ('$char');"
+ sqlite3 "$sdbname" "$sql"
+done
+# Create AA-ZZ
+for ((i=1;i<=26;i++))
+do
+ sql="INSERT INTO columns (title)
+ SELECT (SELECT title FROM columns WHERE id=$i) || title
+ FROM columns where id <= 26;"
+ sqlite3 "$sdbname" "$sql"
+done
+
+#index the sheet name
+sql="CREATE INDEX idx_cd_sheet ON cell_data(sheet);"
+sqlite3 "$sdbname" "$sql"
+# and the sheet with col
+sql="CREATE INDEX idx_cd_sheet_col ON cell_data(sheet,col);"
+sqlite3 "$sdbname" "$sql"
+# and the sheet with row
+sql="CREATE INDEX idx_cd_sheet_row ON cell_data(sheet,row);"
+sqlite3 "$sdbname" "$sql"
+newline="
+"
+#Change the internal separator to CRLF
+IFS=$'\n'
+#walk the table and output the results as csv files.
+# for each sheet (csv file name); for each row, for each value
+sql="SELECT sheet FROM cell_data group by sheet order by sheet;"
+sheets=$(sqlite3 "$sdbname" "$sql")
+for sheet in $sheets
+do
+ #the columns.id field now collates the columns in spreadsheet order
+ # all we need to know is the maximum number of columns per sheet
+ sql="SELECT c.id FROM columns c INNER JOIN cell_data d ON c.title = d.col
+ WHERE sheet='$sheet' ORDER by c.id DESC limit 1;"
+ maxcol=$(sqlite3 "$sdbname" "$sql")
+
+ #no single quotes in filename
+ csv=${sheet//\'/}
+ csv="${curdir}/${dirname}_${csv// /_}.csv"
+
+ #get the rows for the sheet
+ sql="SELECT row FROM cell_data WHERE sheet='$sheet'
+ GROUP BY row ORDER BY row;"
+ rows=$(sqlite3 "$sdbname" "$sql")
+ for row in $rows
+ do
+ #make sure we have a field represented for every column, even if it's empty
+ sql="SELECT d.value FROM columns c left join cell_data d
+ ON c.title = d.col AND d.sheet='$sheet' AND d.row=$row
+ WHERE c.id <= $maxcol;"
+ sqlite3 "$sdbname" "$sql" | #extract the data for the row
+ sed -e 's/"/""/g' -e 's/^/"/' -e 's/$/"/' | #escape embedded quotes
+ tr '\n' ',' | sed "s/,$//" >> "$csv" #convert to csv
+ done
+done
+
+[[ $(hostname) == "wsmkroybal.javelin.pvt" ]] && mv "$sdbname" .
+
+#return to the invocation inode
+popd > /dev/null
+
+#clean up the temp folder
+[[ -z $debug ]] && rm -rf "$dirname"
+
+#clean end
+exit
+
+# GNU GENERAL PUBLIC LICENSE
+# Version 3, 29 June 2007
+#
+# Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+# Everyone is permitted to copy and distribute verbatim copies
+# of this license document, but changing it is not allowed.
+#
+# Preamble
+#
+# The GNU General Public License is a free, copyleft license for
+# software and other kinds of works.
+#
+# The licenses for most software and other practical works are designed
+# to take away your freedom to share and change the works. By contrast,
+# the GNU General Public License is intended to guarantee your freedom to
+# share and change all versions of a program--to make sure it remains free
+# software for all its users. We, the Free Software Foundation, use the
+# GNU General Public License for most of our software; it applies also to
+# any other work released this way by its authors. You can apply it to
+# your programs, too.
+#
+# When we speak of free software, we are referring to freedom, not
+# price. Our General Public Licenses are designed to make sure that you
+# have the freedom to distribute copies of free software (and charge for
+# them if you wish), that you receive source code or can get it if you
+# want it, that you can change the software or use pieces of it in new
+# free programs, and that you know you can do these things.
+#
+# To protect your rights, we need to prevent others from denying you
+# these rights or asking you to surrender the rights. Therefore, you have
+# certain responsibilities if you distribute copies of the software, or if
+# you modify it: responsibilities to respect the freedom of others.
+#
+# For example, if you distribute copies of such a program, whether
+# gratis or for a fee, you must pass on to the recipients the same
+# freedoms that you received. You must make sure that they, too, receive
+# or can get the source code. And you must show them these terms so they
+# know their rights.
+#
+# Developers that use the GNU GPL protect your rights with two steps:
+# (1) assert copyright on the software, and (2) offer you this License
+# giving you legal permission to copy, distribute and/or modify it.
+#
+# For the developers' and authors' protection, the GPL clearly explains
+# that there is no warranty for this free software. For both users' and
+# authors' sake, the GPL requires that modified versions be marked as
+# changed, so that their problems will not be attributed erroneously to
+# authors of previous versions.
+#
+# Some devices are designed to deny users access to install or run
+# modified versions of the software inside them, although the manufacturer
+# can do so. This is fundamentally incompatible with the aim of
+# protecting users' freedom to change the software. The systematic
+# pattern of such abuse occurs in the area of products for individuals to
+# use, which is precisely where it is most unacceptable. Therefore, we
+# have designed this version of the GPL to prohibit the practice for those
+# products. If such problems arise substantially in other domains, we
+# stand ready to extend this provision to those domains in future versions
+# of the GPL, as needed to protect the freedom of users.
+#
+# Finally, every program is threatened constantly by software patents.
+# States should not allow patents to restrict development and use of
+# software on general-purpose computers, but in those that do, we wish to
+# avoid the special danger that patents applied to a free program could
+# make it effectively proprietary. To prevent this, the GPL assures that
+# patents cannot be used to render the program non-free.
+#
+# The precise terms and conditions for copying, distribution and
+# modification follow.
+#
+# TERMS AND CONDITIONS
+#
+# 0. Definitions.
+#
+# "This License" refers to version 3 of the GNU General Public License.
+#
+# "Copyright" also means copyright-like laws that apply to other kinds of
+# works, such as semiconductor masks.
+#
+# "The Program" refers to any copyrightable work licensed under this
+# License. Each licensee is addressed as "you". "Licensees" and
+# "recipients" may be individuals or organizations.
+#
+# To "modify" a work means to copy from or adapt all or part of the work
+# in a fashion requiring copyright permission, other than the making of an
+# exact copy. The resulting work is called a "modified version" of the
+# earlier work or a work "based on" the earlier work.
+#
+# A "covered work" means either the unmodified Program or a work based
+# on the Program.
+#
+# To "propagate" a work means to do anything with it that, without
+# permission, would make you directly or secondarily liable for
+# infringement under applicable copyright law, except executing it on a
+# computer or modifying a private copy. Propagation includes copying,
+# distribution (with or without modification), making available to the
+# public, and in some countries other activities as well.
+#
+# To "convey" a work means any kind of propagation that enables other
+# parties to make or receive copies. Mere interaction with a user through
+# a computer network, with no transfer of a copy, is not conveying.
+#
+# An interactive user interface displays "Appropriate Legal Notices"
+# to the extent that it includes a convenient and prominently visible
+# feature that (1) displays an appropriate copyright notice, and (2)
+# tells the user that there is no warranty for the work (except to the
+# extent that warranties are provided), that licensees may convey the
+# work under this License, and how to view a copy of this License. If
+# the interface presents a list of user commands or options, such as a
+# menu, a prominent item in the list meets this criterion.
+#
+# 1. Source Code.
+#
+# The "source code" for a work means the preferred form of the work
+# for making modifications to it. "Object code" means any non-source
+# form of a work.
+#
+# A "Standard Interface" means an interface that either is an official
+# standard defined by a recognized standards body, or, in the case of
+# interfaces specified for a particular programming language, one that
+# is widely used among developers working in that language.
+#
+# The "System Libraries" of an executable work include anything, other
+# than the work as a whole, that (a) is included in the normal form of
+# packaging a Major Component, but which is not part of that Major
+# Component, and (b) serves only to enable use of the work with that
+# Major Component, or to implement a Standard Interface for which an
+# implementation is available to the public in source code form. A
+# "Major Component", in this context, means a major essential component
+# (kernel, window system, and so on) of the specific operating system
+# (if any) on which the executable work runs, or a compiler used to
+# produce the work, or an object code interpreter used to run it.
+#
+# The "Corresponding Source" for a work in object code form means all
+# the source code needed to generate, install, and (for an executable
+# work) run the object code and to modify the work, including scripts to
+# control those activities. However, it does not include the work's
+# System Libraries, or general-purpose tools or generally available free
+# programs which are used unmodified in performing those activities but
+# which are not part of the work. For example, Corresponding Source
+# includes interface definition files associated with source files for
+# the work, and the source code for shared libraries and dynamically
+# linked subprograms that the work is specifically designed to require,
+# such as by intimate data communication or control flow between those
+# subprograms and other parts of the work.
+#
+# The Corresponding Source need not include anything that users
+# can regenerate automatically from other parts of the Corresponding
+# Source.
+#
+# The Corresponding Source for a work in source code form is that
+# same work.
+#
+# 2. Basic Permissions.
+#
+# All rights granted under this License are granted for the term of
+# copyright on the Program, and are irrevocable provided the stated
+# conditions are met. This License explicitly affirms your unlimited
+# permission to run the unmodified Program. The output from running a
+# covered work is covered by this License only if the output, given its
+# content, constitutes a covered work. This License acknowledges your
+# rights of fair use or other equivalent, as provided by copyright law.
+#
+# You may make, run and propagate covered works that you do not
+# convey, without conditions so long as your license otherwise remains
+# in force. You may convey covered works to others for the sole purpose
+# of having them make modifications exclusively for you, or provide you
+# with facilities for running those works, provided that you comply with
+# the terms of this License in conveying all material for which you do
+# not control copyright. Those thus making or running the covered works
+# for you must do so exclusively on your behalf, under your direction
+# and control, on terms that prohibit them from making any copies of
+# your copyrighted material outside their relationship with you.
+#
+# Conveying under any other circumstances is permitted solely under
+# the conditions stated below. Sublicensing is not allowed; section 10
+# makes it unnecessary.
+#
+# 3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+#
+# No covered work shall be deemed part of an effective technological
+# measure under any applicable law fulfilling obligations under article
+# 11 of the WIPO copyright treaty adopted on 20 December 1996, or
+# similar laws prohibiting or restricting circumvention of such
+# measures.
+#
+# When you convey a covered work, you waive any legal power to forbid
+# circumvention of technological measures to the extent such circumvention
+# is effected by exercising rights under this License with respect to
+# the covered work, and you disclaim any intention to limit operation or
+# modification of the work as a means of enforcing, against the work's
+# users, your or third parties' legal rights to forbid circumvention of
+# technological measures.
+#
+# 4. Conveying Verbatim Copies.
+#
+# You may convey verbatim copies of the Program's source code as you
+# receive it, in any medium, provided that you conspicuously and
+# appropriately publish on each copy an appropriate copyright notice;
+# keep intact all notices stating that this License and any
+# non-permissive terms added in accord with section 7 apply to the code;
+# keep intact all notices of the absence of any warranty; and give all
+# recipients a copy of this License along with the Program.
+#
+# You may charge any price or no price for each copy that you convey,
+# and you may offer support or warranty protection for a fee.
+#
+# 5. Conveying Modified Source Versions.
+#
+# You may convey a work based on the Program, or the modifications to
+# produce it from the Program, in the form of source code under the
+# terms of section 4, provided that you also meet all of these conditions:
+#
+# a) The work must carry prominent notices stating that you modified
+# it, and giving a relevant date.
+#
+# b) The work must carry prominent notices stating that it is
+# released under this License and any conditions added under section
+# 7. This requirement modifies the requirement in section 4 to
+# "keep intact all notices".
+#
+# c) You must license the entire work, as a whole, under this
+# License to anyone who comes into possession of a copy. This
+# License will therefore apply, along with any applicable section 7
+# additional terms, to the whole of the work, and all its parts,
+# regardless of how they are packaged. This License gives no
+# permission to license the work in any other way, but it does not
+# invalidate such permission if you have separately received it.
+#
+# d) If the work has interactive user interfaces, each must display
+# Appropriate Legal Notices; however, if the Program has interactive
+# interfaces that do not display Appropriate Legal Notices, your
+# work need not make them do so.
+#
+# A compilation of a covered work with other separate and independent
+# works, which are not by their nature extensions of the covered work,
+# and which are not combined with it such as to form a larger program,
+# in or on a volume of a storage or distribution medium, is called an
+# "aggregate" if the compilation and its resulting copyright are not
+# used to limit the access or legal rights of the compilation's users
+# beyond what the individual works permit. Inclusion of a covered work
+# in an aggregate does not cause this License to apply to the other
+# parts of the aggregate.
+#
+# 6. Conveying Non-Source Forms.
+#
+# You may convey a covered work in object code form under the terms
+# of sections 4 and 5, provided that you also convey the
+# machine-readable Corresponding Source under the terms of this License,
+# in one of these ways:
+#
+# a) Convey the object code in, or embodied in, a physical product
+# (including a physical distribution medium), accompanied by the
+# Corresponding Source fixed on a durable physical medium
+# customarily used for software interchange.
+#
+# b) Convey the object code in, or embodied in, a physical product
+# (including a physical distribution medium), accompanied by a
+# written offer, valid for at least three years and valid for as
+# long as you offer spare parts or customer support for that product
+# model, to give anyone who possesses the object code either (1) a
+# copy of the Corresponding Source for all the software in the
+# product that is covered by this License, on a durable physical
+# medium customarily used for software interchange, for a price no
+# more than your reasonable cost of physically performing this
+# conveying of source, or (2) access to copy the
+# Corresponding Source from a network server at no charge.
+#
+# c) Convey individual copies of the object code with a copy of the
+# written offer to provide the Corresponding Source. This
+# alternative is allowed only occasionally and noncommercially, and
+# only if you received the object code with such an offer, in accord
+# with subsection 6b.
+#
+# d) Convey the object code by offering access from a designated
+# place (gratis or for a charge), and offer equivalent access to the
+# Corresponding Source in the same way through the same place at no
+# further charge. You need not require recipients to copy the
+# Corresponding Source along with the object code. If the place to
+# copy the object code is a network server, the Corresponding Source
+# may be on a different server (operated by you or a third party)
+# that supports equivalent copying facilities, provided you maintain
+# clear directions next to the object code saying where to find the
+# Corresponding Source. Regardless of what server hosts the
+# Corresponding Source, you remain obligated to ensure that it is
+# available for as long as needed to satisfy these requirements.
+#
+# e) Convey the object code using peer-to-peer transmission, provided
+# you inform other peers where the object code and Corresponding
+# Source of the work are being offered to the general public at no
+# charge under subsection 6d.
+#
+# A separable portion of the object code, whose source code is excluded
+# from the Corresponding Source as a System Library, need not be
+# included in conveying the object code work.
+#
+# A "User Product" is either (1) a "consumer product", which means any
+# tangible personal property which is normally used for personal, family,
+# or household purposes, or (2) anything designed or sold for incorporation
+# into a dwelling. In determining whether a product is a consumer product,
+# doubtful cases shall be resolved in favor of coverage. For a particular
+# product received by a particular user, "normally used" refers to a
+# typical or common use of that class of product, regardless of the status
+# of the particular user or of the way in which the particular user
+# actually uses, or expects or is expected to use, the product. A product
+# is a consumer product regardless of whether the product has substantial
+# commercial, industrial or non-consumer uses, unless such uses represent
+# the only significant mode of use of the product.
+#
+# "Installation Information" for a User Product means any methods,
+# procedures, authorization keys, or other information required to install
+# and execute modified versions of a covered work in that User Product from
+# a modified version of its Corresponding Source. The information must
+# suffice to ensure that the continued functioning of the modified object
+# code is in no case prevented or interfered with solely because
+# modification has been made.
+#
+# If you convey an object code work under this section in, or with, or
+# specifically for use in, a User Product, and the conveying occurs as
+# part of a transaction in which the right of possession and use of the
+# User Product is transferred to the recipient in perpetuity or for a
+# fixed term (regardless of how the transaction is characterized), the
+# Corresponding Source conveyed under this section must be accompanied
+# by the Installation Information. But this requirement does not apply
+# if neither you nor any third party retains the ability to install
+# modified object code on the User Product (for example, the work has
+# been installed in ROM).
+#
+# The requirement to provide Installation Information does not include a
+# requirement to continue to provide support service, warranty, or updates
+# for a work that has been modified or installed by the recipient, or for
+# the User Product in which it has been modified or installed. Access to a
+# network may be denied when the modification itself materially and
+# adversely affects the operation of the network or violates the rules and
+# protocols for communication across the network.
+#
+# Corresponding Source conveyed, and Installation Information provided,
+# in accord with this section must be in a format that is publicly
+# documented (and with an implementation available to the public in
+# source code form), and must require no special password or key for
+# unpacking, reading or copying.
+#
+# 7. Additional Terms.
+#
+# "Additional permissions" are terms that supplement the terms of this
+# License by making exceptions from one or more of its conditions.
+# Additional permissions that are applicable to the entire Program shall
+# be treated as though they were included in this License, to the extent
+# that they are valid under applicable law. If additional permissions
+# apply only to part of the Program, that part may be used separately
+# under those permissions, but the entire Program remains governed by
+# this License without regard to the additional permissions.
+#
+# When you convey a copy of a covered work, you may at your option
+# remove any additional permissions from that copy, or from any part of
+# it. (Additional permissions may be written to require their own
+# removal in certain cases when you modify the work.) You may place
+# additional permissions on material, added by you to a covered work,
+# for which you have or can give appropriate copyright permission.
+#
+# Notwithstanding any other provision of this License, for material you
+# add to a covered work, you may (if authorized by the copyright holders of
+# that material) supplement the terms of this License with terms:
+#
+# a) Disclaiming warranty or limiting liability differently from the
+# terms of sections 15 and 16 of this License; or
+#
+# b) Requiring preservation of specified reasonable legal notices or
+# author attributions in that material or in the Appropriate Legal
+# Notices displayed by works containing it; or
+#
+# c) Prohibiting misrepresentation of the origin of that material, or
+# requiring that modified versions of such material be marked in
+# reasonable ways as different from the original version; or
+#
+# d) Limiting the use for publicity purposes of names of licensors or
+# authors of the material; or
+#
+# e) Declining to grant rights under trademark law for use of some
+# trade names, trademarks, or service marks; or
+#
+# f) Requiring indemnification of licensors and authors of that
+# material by anyone who conveys the material (or modified versions of
+# it) with contractual assumptions of liability to the recipient, for
+# any liability that these contractual assumptions directly impose on
+# those licensors and authors.
+#
+# All other non-permissive additional terms are considered "further
+# restrictions" within the meaning of section 10. If the Program as you
+# received it, or any part of it, contains a notice stating that it is
+# governed by this License along with a term that is a further
+# restriction, you may remove that term. If a license document contains
+# a further restriction but permits relicensing or conveying under this
+# License, you may add to a covered work material governed by the terms
+# of that license document, provided that the further restriction does
+# not survive such relicensing or conveying.
+#
+# If you add terms to a covered work in accord with this section, you
+# must place, in the relevant source files, a statement of the
+# additional terms that apply to those files, or a notice indicating
+# where to find the applicable terms.
+#
+# Additional terms, permissive or non-permissive, may be stated in the
+# form of a separately written license, or stated as exceptions;
+# the above requirements apply either way.
+#
+# 8. Termination.
+#
+# You may not propagate or modify a covered work except as expressly
+# provided under this License. Any attempt otherwise to propagate or
+# modify it is void, and will automatically terminate your rights under
+# this License (including any patent licenses granted under the third
+# paragraph of section 11).
+#
+# However, if you cease all violation of this License, then your
+# license from a particular copyright holder is reinstated (a)
+# provisionally, unless and until the copyright holder explicitly and
+# finally terminates your license, and (b) permanently, if the copyright
+# holder fails to notify you of the violation by some reasonable means
+# prior to 60 days after the cessation.
+#
+# Moreover, your license from a particular copyright holder is
+# reinstated permanently if the copyright holder notifies you of the
+# violation by some reasonable means, this is the first time you have
+# received notice of violation of this License (for any work) from that
+# copyright holder, and you cure the violation prior to 30 days after
+# your receipt of the notice.
+#
+# Termination of your rights under this section does not terminate the
+# licenses of parties who have received copies or rights from you under
+# this License. If your rights have been terminated and not permanently
+# reinstated, you do not qualify to receive new licenses for the same
+# material under section 10.
+#
+# 9. Acceptance Not Required for Having Copies.
+#
+# You are not required to accept this License in order to receive or
+# run a copy of the Program. Ancillary propagation of a covered work
+# occurring solely as a consequence of using peer-to-peer transmission
+# to receive a copy likewise does not require acceptance. However,
+# nothing other than this License grants you permission to propagate or
+# modify any covered work. These actions infringe copyright if you do
+# not accept this License. Therefore, by modifying or propagating a
+# covered work, you indicate your acceptance of this License to do so.
+#
+# 10. Automatic Licensing of Downstream Recipients.
+#
+# Each time you convey a covered work, the recipient automatically
+# receives a license from the original licensors, to run, modify and
+# propagate that work, subject to this License. You are not responsible
+# for enforcing compliance by third parties with this License.
+#
+# An "entity transaction" is a transaction transferring control of an
+# organization, or substantially all assets of one, or subdividing an
+# organization, or merging organizations. If propagation of a covered
+# work results from an entity transaction, each party to that
+# transaction who receives a copy of the work also receives whatever
+# licenses to the work the party's predecessor in interest had or could
+# give under the previous paragraph, plus a right to possession of the
+# Corresponding Source of the work from the predecessor in interest, if
+# the predecessor has it or can get it with reasonable efforts.
+#
+# You may not impose any further restrictions on the exercise of the
+# rights granted or affirmed under this License. For example, you may
+# not impose a license fee, royalty, or other charge for exercise of
+# rights granted under this License, and you may not initiate litigation
+# (including a cross-claim or counterclaim in a lawsuit) alleging that
+# any patent claim is infringed by making, using, selling, offering for
+# sale, or importing the Program or any portion of it.
+#
+# 11. Patents.
+#
+# A "contributor" is a copyright holder who authorizes use under this
+# License of the Program or a work on which the Program is based. The
+# work thus licensed is called the contributor's "contributor version".
+#
+# A contributor's "essential patent claims" are all patent claims
+# owned or controlled by the contributor, whether already acquired or
+# hereafter acquired, that would be infringed by some manner, permitted
+# by this License, of making, using, or selling its contributor version,
+# but do not include claims that would be infringed only as a
+# consequence of further modification of the contributor version. For
+# purposes of this definition, "control" includes the right to grant
+# patent sublicenses in a manner consistent with the requirements of
+# this License.
+#
+# Each contributor grants you a non-exclusive, worldwide, royalty-free
+# patent license under the contributor's essential patent claims, to
+# make, use, sell, offer for sale, import and otherwise run, modify and
+# propagate the contents of its contributor version.
+#
+# In the following three paragraphs, a "patent license" is any express
+# agreement or commitment, however denominated, not to enforce a patent
+# (such as an express permission to practice a patent or covenant not to
+# sue for patent infringement). To "grant" such a patent license to a
+# party means to make such an agreement or commitment not to enforce a
+# patent against the party.
+#
+# If you convey a covered work, knowingly relying on a patent license,
+# and the Corresponding Source of the work is not available for anyone
+# to copy, free of charge and under the terms of this License, through a
+# publicly available network server or other readily accessible means,
+# then you must either (1) cause the Corresponding Source to be so
+# available, or (2) arrange to deprive yourself of the benefit of the
+# patent license for this particular work, or (3) arrange, in a manner
+# consistent with the requirements of this License, to extend the patent
+# license to downstream recipients. "Knowingly relying" means you have
+# actual knowledge that, but for the patent license, your conveying the
+# covered work in a country, or your recipient's use of the covered work
+# in a country, would infringe one or more identifiable patents in that
+# country that you have reason to believe are valid.
+#
+# If, pursuant to or in connection with a single transaction or
+# arrangement, you convey, or propagate by procuring conveyance of, a
+# covered work, and grant a patent license to some of the parties
+# receiving the covered work authorizing them to use, propagate, modify
+# or convey a specific copy of the covered work, then the patent license
+# you grant is automatically extended to all recipients of the covered
+# work and works based on it.
+#
+# A patent license is "discriminatory" if it does not include within
+# the scope of its coverage, prohibits the exercise of, or is
+# conditioned on the non-exercise of one or more of the rights that are
+# specifically granted under this License. You may not convey a covered
+# work if you are a party to an arrangement with a third party that is
+# in the business of distributing software, under which you make payment
+# to the third party based on the extent of your activity of conveying
+# the work, and under which the third party grants, to any of the
+# parties who would receive the covered work from you, a discriminatory
+# patent license (a) in connection with copies of the covered work
+# conveyed by you (or copies made from those copies), or (b) primarily
+# for and in connection with specific products or compilations that
+# contain the covered work, unless you entered into that arrangement,
+# or that patent license was granted, prior to 28 March 2007.
+#
+# Nothing in this License shall be construed as excluding or limiting
+# any implied license or other defenses to infringement that may
+# otherwise be available to you under applicable patent law.
+#
+# 12. No Surrender of Others' Freedom.
+#
+# If conditions are imposed on you (whether by court order, agreement or
+# otherwise) that contradict the conditions of this License, they do not
+# excuse you from the conditions of this License. If you cannot convey a
+# covered work so as to satisfy simultaneously your obligations under this
+# License and any other pertinent obligations, then as a consequence you may
+# not convey it at all. For example, if you agree to terms that obligate you
+# to collect a royalty for further conveying from those to whom you convey
+# the Program, the only way you could satisfy both those terms and this
+# License would be to refrain entirely from conveying the Program.
+#
+# 13. Use with the GNU Affero General Public License.
+#
+# Notwithstanding any other provision of this License, you have
+# permission to link or combine any covered work with a work licensed
+# under version 3 of the GNU Affero General Public License into a single
+# combined work, and to convey the resulting work. The terms of this
+# License will continue to apply to the part which is the covered work,
+# but the special requirements of the GNU Affero General Public License,
+# section 13, concerning interaction through a network will apply to the
+# combination as such.
+#
+# 14. Revised Versions of this License.
+#
+# The Free Software Foundation may publish revised and/or new versions of
+# the GNU General Public License from time to time. Such new versions will
+# be similar in spirit to the present version, but may differ in detail to
+# address new problems or concerns.
+#
+# Each version is given a distinguishing version number. If the
+# Program specifies that a certain numbered version of the GNU General
+# Public License "or any later version" applies to it, you have the
+# option of following the terms and conditions either of that numbered
+# version or of any later version published by the Free Software
+# Foundation. If the Program does not specify a version number of the
+# GNU General Public License, you may choose any version ever published
+# by the Free Software Foundation.
+#
+# If the Program specifies that a proxy can decide which future
+# versions of the GNU General Public License can be used, that proxy's
+# public statement of acceptance of a version permanently authorizes you
+# to choose that version for the Program.
+#
+# Later license versions may give you additional or different
+# permissions. However, no additional obligations are imposed on any
+# author or copyright holder as a result of your choosing to follow a
+# later version.
+#
+# 15. Disclaimer of Warranty.
+#
+# THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+# APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+# HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+# OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+# IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+# ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+#
+# 16. Limitation of Liability.
+#
+# IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+# WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+# THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+# GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+# USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+# DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+# PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+# EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGES.
+#
+# 17. Interpretation of Sections 15 and 16.
+#
+# If the disclaimer of warranty and limitation of liability provided
+# above cannot be given local legal effect according to their terms,
+# reviewing courts shall apply local law that most closely approximates
+# an absolute waiver of all civil liability in connection with the
+# Program, unless a warranty or assumption of liability accompanies a
+# copy of the Program in return for a fee.
+#
+# END OF TERMS AND CONDITIONS
+
+
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+<xsl:output method="text"/>
+
+<xsl:template match="sheetData">
+ <xsl:apply-templates select="row"/>
+</xsl:template>
+
+<xsl:template match="row">
+ <xsl:for-each select="*">
+ <xsl:value-of select="'INSERT INTO cell_data (cell,style,type,value) VALUES (|'"/>
+ <xsl:value-of select="@r"/> <!-- cell identifier -->
+ <xsl:value-of select="'|,|'"/>
+ <xsl:value-of select="@s"/> <!-- format -->
+ <xsl:value-of select="'|,|'"/>
+ <xsl:value-of select="@t"/> <!-- data type -->
+ <xsl:value-of select="'|,|'"/>
+ <xsl:value-of select="v"/> <!-- the calculated value -->
+ <xsl:value-of select="'|);'"/>
+ <xsl:if test="position() != last()">
+ <!-- <xsl:value-of select="');'"/> -->
+ <xsl:text>&#10;</xsl:text>
+ </xsl:if>
+ </xsl:for-each>
+ <xsl:text>&#10;</xsl:text>
+</xsl:template>
+
+</xsl:stylesheet>